package com.supermap.samplecode.data;

import java.awt.event.MouseEvent;

import javax.swing.JTextArea;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import com.supermap.data.Dataset;
import com.supermap.data.Datasets;
import com.supermap.data.Datasource;
import com.supermap.data.SymbolGroup;
import com.supermap.data.Workspace;
import com.supermap.data.WorkspaceConnectionInfo;
import com.supermap.data.WorkspaceType;
import com.supermap.layout.LayoutElements;
import com.supermap.layout.MapLayout;
import com.supermap.mapping.Layer;
import com.supermap.mapping.Layers;
import com.supermap.mapping.Map;

/**
 * <p>
 * Title:工作空间树状结构
 * </p>
 * 
 * <p>
 * Description:
 * ============================================================================>
 * ------------------------------版权声明----------------------------
 * 此文件为SuperMap Objects Java 的示范代码 
 * 版权所有：北京超图软件股份有限公司
 * ----------------------------------------------------------------
 * ---------------------SuperMap iObjects Java 示范程序说明------------------------
 * 
 * 1、范例简介：展示工作空间的树状结构，包括数据源、地图、三维场景、布局、符号库
 * 2、示例数据：安装目录\SampleData\City\Changchun.smwu；
 * 3、关键类型/成员: 
 *      Workspace.getDatasources 方法
 *      Workspace.getMaps 方法
 *      Workspace.getScenes 方法
 *      Workspace.getLayouts 方法
 *      Workspace.getResources 方法
 * 4、使用步骤：
 *  (1)点击数据集叶节点，可得到数据集相关信息
 *  (2)点击地图叶节点，可得到地图及图层的基本信息
 *  (3)点击三维场景叶节点，可得到三维场景的基本信息
 *  (4)点击布局叶节点，可得到布局的基本信息
 *  (5)点击符号库叶节点，可得到符号库中符号的名称
 * ------------------------------------------------------------------------------
 * ============================================================================>
 * </p> 
 * 
 * <p>
 * Company: 北京超图软件股份有限公司
 * </p>
 * 
 */

/**
 * <p>
 * Title:工作空间树状结构
 * </p>
 * 
 * <p>
 * Description:
 * ============================================================================>
 * ------------------------------Copyright Statement----------------------------
 * SuperMap Objects Java Sample Code 
 * Copyright: SuperMap Software Co., Ltd. All Rights Reserved.
 * ------------------------------------------------------------------------------
 *-----------------------Description--------------------------
 * 
 * 1、Sample Code Description：This sample demonstrates the tree structure of workspace including datasource, map, scene, layout,symbol library.
 * 2、Sample Data Location：Installation directory\SampleData\City\Changchun.smwu；
 * 3、Key Classes/Methods
 *      Workspace.getDatasources method
 *      Workspace.getMaps method
 *      Workspace.getScenes method
 *      Workspace.getLayouts method
 *      Workspace.getResources method
 * 4、Procedures:
 *  (1)Click the node of datasources to get the information of the datasources.
 *  (2)Click the node of maps to get the information of the maps and layers.
 *  (3)Click the node of scenes to get the information of the scenes.
 *  (4)Click the node of layouts to get the information of the layouts.
 *  (5)Click the node of resources to get the information of the resources.
 * ------------------------------------------------------------------------------
 * ============================================================================>
 * </p> 
 * 
 * <p>
 * Company: SuperMap Software Co., Ltd.
 * </p>
 * 
 */

public class SampleRun {
	
	private Workspace m_workspace;

	//执行程序所需要的数据
	//Data
	
	private String m_name1 = "";
	private String m_name2 = "";
	private String m_name3 = "";
	private String m_name4 = "";
	private String m_libraryName1 = "";
	private String m_libraryName2 = "";
	private String m_libraryName3 = "";
	private String m_symbolindex = "";
	private String m_datasetinfo1 = "";
	private String m_datasetinfo2 = "";
	private String m_datasetinfo3 = "";
	private String m_datasetinfo4 = "";
	private String m_datasetinfo5 = "";
	private String m_datasetinfo6 = "";
	private String m_datasetinfo7 = "";
	private String m_datasetinfo8 = "";
	private String m_datasetinfo9 = "";
	private String m_mapinfo1 = "";
	private String m_mapinfo2 = "";
	private String m_mapinfo3 = "";
	private String m_mapinfo4 = "";
	private String m_mapinfo5 = "";
	private String m_mapinfo6 = "";
	private String m_mapinfo7 = "";
	private String m_mapinfo8 = "";
	private String m_mapinfo9 = "";
	private String m_mapinfo10 = "";
	private String m_mapinfo11 = "";
	private String m_mapinfo12 = "";
	private String m_mapinfo13 = "";
	private String m_mapinfo14 = "";
	private String m_mapinfo15 = "";
	private String m_mapinfo16 = "";
	private String m_mapinfo17 = "";
	private String m_mapinfo18 = "";
	private String m_mapinfo19 = "";
	private String m_mapinfo20 = "";
	private String m_mapinfo21 = "";
	private String m_mapinfo22 = "";
	private String m_mapinfo23 = "";
	private String m_mapinfo24 = "";
	private String m_mapinfo25 = "";
	private String m_mapinfo26 = "";
	private String m_mapinfo27 = "";
	private String m_mapinfo28 = "";
	private String m_layoutinfo1 = "";
	private String m_layoutinfo2 = "";
	private String m_layoutinfo3 = "";
	private String m_layoutinfo4 = "";
	private String m_layoutinfo5 = "";
	private String m_layoutinfo6 = "";
	private String m_layoutinfo7 = "";
	/**
	 * 根据workspace构造 SampleRun对象
	 * Initialize the SampleRun object with the specified workspace.
	 */
	public SampleRun(Workspace workspace) {
		this.m_workspace = workspace;
		InitializeCultureResources();
		initialize();
	}
	
	/**
	* 初始化多语言资源
	* Initialize CultureResources
	*/
	private void InitializeCultureResources()
	{
		if(com.supermap.data.Environment.getCurrentCulture().contentEquals("zh-CN"))
		{
			m_name1 = "地图";
			m_name2 = "三维场景";
			m_name3 = "布局";
			m_name4 = "资源";
			m_libraryName1 = "符号库";
			m_libraryName2 = "线型库";
			m_libraryName3 = "填充库";
			m_symbolindex = "符号索引";
			m_datasetinfo1 = "所属数据源：";
			m_datasetinfo2 = "数据集名：";
			m_datasetinfo3 = "描述信息：";
			m_datasetinfo4 = "数据表名：";
			m_datasetinfo5 = "类型：";
			m_datasetinfo6 = "最小外接矩形：";
			m_datasetinfo7 = "编码方式：";
			m_datasetinfo8 = "是否已经打开：";
			m_datasetinfo9 = "是否只读:";
			m_mapinfo1 = "关联的工作空间：";
			m_mapinfo2 = "地图名：";
			m_mapinfo3 = "描述信息：";
			m_mapinfo4 = "空间范围：";
			m_mapinfo5 = "中心点：";
			m_mapinfo6 = "颜色模式：";
			m_mapinfo7 = "坐标单位：";
			m_mapinfo8 = "比例尺：";
			m_mapinfo9 = "是否反走样：";
			m_mapinfo10 = "自定义地图边界是否有效：";
			m_mapinfo11 = "是否动态投影显示：";
			m_mapinfo12 = "是否被修改：";
			m_mapinfo13 = "是否绘制地图背景：";
			m_mapinfo14 = "文本角度是否固定：";
			m_mapinfo15 = "图层信息：\n";
			m_mapinfo16 = "图层总数：";
			m_mapinfo17 = "图层编号";
			m_mapinfo18 = "图层名：";
			m_mapinfo19 = "对应数据集：";
			m_mapinfo20 = "过滤条件：";
			m_mapinfo21 = "不透明度：";
			m_mapinfo22 = "制图表达字段：";
			m_mapinfo23 = "专题图：";
			m_mapinfo24 = "是否可见：";
			m_mapinfo25 = "图层是否可编辑：";
			m_mapinfo26 = "是否采用制图表达";
			m_mapinfo27 = "图层中对象是否可选择：";
			m_mapinfo28 = "是否可捕捉：";
			m_layoutinfo1 = "关联的工作空间：";
			m_layoutinfo2 = "布局名：";
			m_layoutinfo3 = "空间范围：";
			m_layoutinfo4 = "中心点：";
			m_layoutinfo5 = "布局元素信息：\n";
			m_layoutinfo6 = "布局元素总数：";
			m_layoutinfo7 = "布局元素编号：";
		}
		else
		{
			m_name1 = "maps";
			m_name2 = "scenes";
			m_name3 = "layouts";
			m_name4 = "resources";
			m_libraryName1 = "SymbolMarkerLibrary";
			m_libraryName2 = "SymbolLineLibrary";
			m_libraryName3 = "SymbolFillLibrary";
			m_symbolindex = "SymbolIndex";
			m_datasetinfo1 = "From which datasource:";
			m_datasetinfo2 = "Dataset name：";
			m_datasetinfo3 = "Description：";
			m_datasetinfo4 = "Table Name：";
			m_datasetinfo5 = "Type：";
			m_datasetinfo6 = "Bounds：";
			m_datasetinfo7 = "EncodeType：";
			m_datasetinfo8 = "Is open：";
			m_datasetinfo9 = "Is read only:";
			m_mapinfo1 = "Workspace:";
			m_mapinfo2 = "Mapname:";
			m_mapinfo3 = "Description:";
			m_mapinfo4 = "Space range(Bounds):";
			m_mapinfo5 = "Center point:";
			m_mapinfo6 = "Color mode:";
			m_mapinfo7 = "Coordinate unit:";
			m_mapinfo8 = "Scale:";
			m_mapinfo9 = "Is antialias:";
			m_mapinfo10 = "Is custom bounds enabled:";
			m_mapinfo11 = "Is dynamic projection:";
			m_mapinfo12 = "Is modified:";
			m_mapinfo13 = "Is paint backgroumd:";
			m_mapinfo14 = "Is text angle fixed:";
			m_mapinfo15 = "Layers information:\n";
			m_mapinfo16 = "Layers total count:";
			m_mapinfo17 = "Layer serial number:";
			m_mapinfo18 = "Layer name:";
			m_mapinfo19 = "Dataset:";
			m_mapinfo20 = "Display filter:";
			m_mapinfo21 = "Opaque rate:";
			m_mapinfo22 = "Representation field:";
			m_mapinfo23 = "Themtic maps:";
			m_mapinfo24 = "Is visible:";
			m_mapinfo25 = "Is editable:";
			m_mapinfo26 = "Is representation enabled:";
			m_mapinfo27 = "Is selectable:";
			m_mapinfo28 = "Is snapable:";
			m_layoutinfo1 = "Workspace:";
			m_layoutinfo2 = "Layout name:";
			m_layoutinfo3 = "Space range(Bounds):";
			m_layoutinfo4 = "Center point:";
			m_layoutinfo5 = "Layout elements information:\n";
			m_layoutinfo6 = "Total layout elements:";
			m_layoutinfo7 = "Element number:";
		}
	}
	
	/**
	 * 鼠标点击触发，向文本域中添加信息 
	 * Add information to the text.
	 */
	public void doMousePressed(MouseEvent e, JTree tree, JTextArea textArea) {
		TreePath path = tree.getPathForLocation(e.getX(), e.getY());
		tree.setSelectionPath(path);
		TreePath treepath = tree.getSelectionPath();
		if (treepath == null) {
			return;
		}
		DefaultMutableTreeNode node = (DefaultMutableTreeNode)treepath.getLastPathComponent();
		int pathNum = path.getPathCount();
		
		if (pathNum == 4 && node.isLeaf() && e.getClickCount() == 1) {
			String datasourceName = node.getParent().toString();
			Datasource datasource = m_workspace.getDatasources().get(
					datasourceName);
			Datasets datasets = datasource.getDatasets();
			String datasetName = node.toString();
			if (datasets.indexOf(datasetName) != -1) {
				Dataset dataset = datasets.get(datasetName);
				appendDatasetInfo(dataset, textArea);
			}
		} else if (pathNum == 3 && node.isLeaf() && e.getClickCount() == 1) {
			String name = node.getParent().toString();
			if (name.equals(m_name1)) {
				String mapName = node.toString();
				Map map = new Map(m_workspace);
				map.open(mapName);
				appendMapInfo(map, textArea);
			} else if (name.equals(m_name2)) {
				textArea.append(node.toString());
			} else if (name.equals(m_name3)) {
				String mapLayoutName = node.toString();
				MapLayout mapLayout = new MapLayout(m_workspace);
				mapLayout.open(mapLayoutName);
				appendMapLayoutInfo(mapLayout, textArea);
			} else if (name.endsWith(m_name4)) {
				String libraryName = node.toString();
				if (libraryName.equals(m_libraryName1)) {
					SymbolGroup symbolGroup = m_workspace.getResources().getMarkerLibrary().getRootGroup();
					int count = symbolGroup.getCount();
					
					for (int i = 0; i < count; i++) {
						textArea.append(m_symbolindex + i + ": " + symbolGroup.get(i).getName() + "\n");
					}
				} else if (libraryName.equals(m_libraryName2)) {
					SymbolGroup symbolGroup = m_workspace.getResources().getLineLibrary().getRootGroup();
					int count = symbolGroup.getCount();
					
					for (int i = 0; i < count; i++) {
						textArea.append(m_symbolindex + i + ": " + symbolGroup.get(i).getName() + "\n");
					}
				} else if (libraryName.equals(m_libraryName3)) {
					SymbolGroup symbolGroup = m_workspace.getResources().getFillLibrary().getRootGroup();
					int count = symbolGroup.getCount();
					
					for (int i = 0; i < count; i++) {
						textArea.append(m_symbolindex + i + ": " + symbolGroup.get(i).getName() + "\n");
					}
				}
			}
		}
	}
	
	/**
	 * 取得数据集信息，添加到文本域中 
	 * Add the dataset information to the text.
	 */
	private void appendDatasetInfo(Dataset dataset, JTextArea textArea) {
		try {
			textArea.append(m_datasetinfo1 + dataset.getDatasource().getAlias() + "\n"	);
			textArea.append(m_datasetinfo2 + dataset.getName() + "\n");
			textArea.append(m_datasetinfo3 + dataset.getDescription() + "\n");
			textArea.append(m_datasetinfo4 + dataset.getTableName() + "\n");
			textArea.append(m_datasetinfo5 + dataset.getType().toString() + "\n");
			textArea.append(m_datasetinfo6 + dataset.getBounds().toString() + "\n");
			textArea.append(m_datasetinfo7 + dataset.getEncodeType().toString() + "\n");
			textArea.append(m_datasetinfo8 + dataset.isOpen() + "\n"); 
			textArea.append(m_datasetinfo9 + dataset.isOpen() + "\n"); 
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
	}
	
	/**
	 * 取得地图信息，添加到文本域中 
	 * Add the map information to the text.
	 */
	private void appendMapInfo(Map map, JTextArea textArea) {
		try {
			textArea.append(m_mapinfo1 + map.getWorkspace().getCaption() + "\n");
			textArea.append(m_mapinfo2 + map.getName() + "\n");
			textArea.append(m_mapinfo3 + map.getDescription() + "\n");
			textArea.append(m_mapinfo4 + map.getBounds().toString() + "\n");
			textArea.append(m_mapinfo5 + map.getCenter().toString() + "\n");
			textArea.append(m_mapinfo6 + map.getColorMode().toString() + "\n");
			textArea.append(m_mapinfo7 + map.getCoordUnit().toString() + "\n");
			textArea.append(m_mapinfo8 + map.getScale() + "\n"); 
			textArea.append(m_mapinfo9 + map.isAntialias() + "\n"); 
			textArea.append(m_mapinfo10 + map.isCustomBoundsEnabled() + "\n"); 
			textArea.append(m_mapinfo11 + map.isDynamicProjection() + "\n"); 
			textArea.append(m_mapinfo12 + map.isModified() + "\n"); 
			textArea.append(m_mapinfo13 + map.isPaintBackground() + "\n"); 
			textArea.append(m_mapinfo14 + map.isTextAngleFixed() + "\n"); 			
			textArea.append("**************************************\n");
			
			textArea.append(m_mapinfo15);
			Layers layers = map.getLayers();
			textArea.append(m_mapinfo16 + layers.getCount() + "\n");
			for (int i = 0; i < layers.getCount(); i++) {
				Layer layer = layers.get(i);
				textArea.append(m_mapinfo17 + i + "：" + layer.getCaption() + "\n"); 
				textArea.append(m_mapinfo18 + layer.getName() + "\n"	);
				textArea.append(m_mapinfo3 + layer.getDescription() + "\n");
				textArea.append(m_mapinfo19 + layer.getDataset().getName() + "\n");
				textArea.append(m_mapinfo20 + layer.getDisplayFilter().toString()); 
				textArea.append(m_mapinfo21 + layer.getOpaqueRate() + "\n");
				textArea.append(m_mapinfo22 + layer.getRepresentationField() + "\n");
				if (layer.getTheme() != null) {
					textArea.append(m_mapinfo23 + layer.getTheme().toString());
				}
				textArea.append(m_mapinfo24 + layer.isVisible() + "\n");
				textArea.append(m_mapinfo25 + layer.isEditable() + "\n");
				textArea.append(m_mapinfo26 + layer.isRepresentationEnabled() + "\n");
				textArea.append(m_mapinfo27 + layer.isSelectable() + "\n");
				textArea.append(m_mapinfo28 + layer.isSnapable() + "\n");
				textArea.append("\n");
			}
			
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
	}
	
	/**
	 * 取得布局信息，添加到文本域
	 * Add the layout information to the text.
	 */
	private void appendMapLayoutInfo(MapLayout mapLayout, JTextArea textArea) {
		try {
			textArea.append(m_layoutinfo1 + mapLayout.getWorkspace().getCaption() + "\n");
			textArea.append(m_layoutinfo2 + mapLayout.getName() + "\n");
			textArea.append(m_layoutinfo3 + mapLayout.getBounds().toString() + "\n");
			textArea.append(m_layoutinfo4 + mapLayout.getCenter().toString() + "\n");
			textArea.append("**************************************\n");
			
			textArea.append(m_layoutinfo5);
			LayoutElements layoutElements = mapLayout.getElements();
			textArea.append(m_layoutinfo6 + layoutElements.getCount() + "\n");
			int index = -1;
			while (!layoutElements.isEOF()) {
				index++;
				textArea.append(m_layoutinfo7 + index + "：" + layoutElements.getGeometry().getType()); 
				layoutElements.moveNext();
			}
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
	}
	
	/**
	 * 打开需要的工作空间文件及地图
	 * Open the workspace and map.
	 */
	private void initialize() {
		try {
			// 打开工作空间及地图
			// Open the workspace and map.
			WorkspaceConnectionInfo conInfo = new WorkspaceConnectionInfo(
					"../../SampleData/City/Changchun.smwu");
			conInfo.setType(WorkspaceType.SMWU);
			m_workspace.open(conInfo);

		} catch (Exception ex) {
			System.out.println(ex.getMessage());
		}
	}
}

